stages:
    - update
    - tagging

update-Gesamt-Schematron:
  stage: update
  rules:
    # job runs only for tags with the format MAJOR.MINOR.PATCH+YYYYMMDD-MAJOR.MINOR.PATCH
    - if: '$CI_COMMIT_TAG =~ /^(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\+((19|20)[0-9][0-9](0[1-9]|1[012])(0[1-9]|[12][0-9]|3[01]))\-(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)$/'

  before_script:
    # concatenate user's login name with '_GITLAB_CI_TOKEN' in order to access environment variable
    - tmp_GITLAB_CI_TOKEN=${GITLAB_USER_LOGIN}_GITLAB_CI_TOKEN
    - export GITLAB_CI_TOKEN=${!tmp_GITLAB_CI_TOKEN}
    # set up git config
    - git config --global user.email "$GITLAB_USER_EMAIL"
    - git config --global user.name "$GITLAB_USER_NAME"

  script:
    # echo the tag the job is running for
    - echo ${CI_COMMIT_TAG}

    # append the tag to the end of all *.sch files, example "<!-- versionLabel="4.12.0+20230118-1.3.1" -->"
    - > # start shell variable with yaml multiline block
      for file in $(find . -maxdepth 1 -name "*.sch"); do
        echo '<!-- versionLabel="'${CI_COMMIT_TAG}'" -->' >> $file
      done

    # clone current master branch from project "CDA Gesamt-Schematron"
    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/elga-gmbh/cda-schematron/cda-gesamt-schematron.git

    # copy all contents of current include directory to Gesamt-Schematron's include directory
    - cp ./include/* ./cda-gesamt-schematron/include/

    # copy all *.sch files to Gesamt-Schematron
    - cp *.sch ./cda-gesamt-schematron/

    # change to Gesamt-Schematron's directory
    - cd cda-gesamt-schematron

    # stage all files
    - git add *

    # commit all files
    - git commit -m "Update at-lab-Schematron to version $CI_COMMIT_TAG"

    # push to remote repository
    - git push "https://${GITLAB_USER_LOGIN}:${GITLAB_CI_TOKEN}@gitlab.com/elga-gmbh/cda-schematron/cda-gesamt-schematron.git" master

tag-Gesamt-Schematron:
  stage: tagging
  rules:
    # job runs only for tags with the format MAJOR.MINOR.PATCH+YYYYMMDD-MAJOR.MINOR.PATCH
    - if: '$CI_COMMIT_TAG =~ /^(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\+((19|20)[0-9][0-9](0[1-9]|1[012])(0[1-9]|[12][0-9]|3[01]))\-(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)$/'
  trigger:
    project: elga-gmbh/cda-schematron/cda-gesamt-schematron
    branch: master
    strategy: depend


#
# ACHTUNG: Der folgende Teil muss überarbeitet werden, sobald die automatische Schematron-Validierung in GitLab eingerichtet wird und funktionieren soll!
#
#default:
#  image:
#    name: elgagmbh/saxon
#  # All jobs are interruptible by default
#  interruptible: true
#  # Default job timeout set to 5m
#  timeout: 5m
#
#test:
#  stage: test
#  script:
#    # clone current master branch from project "CDA Beispielbefunde"
#    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/elga-gmbh/cda-beispielbefunde.git
#
#    # clone current master branch from project "Schematron Validator"
#    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/elga-gmbh/schematron-validator.git
#
#    # move everything from directory schematron-validator to the current directory
#    - mv ./schematron-validator/* .
#
#    # make validate.sh executable
#    - chmod 744 validate.sh
#
#    # execute validation of sample files against schematron
#    - ./validate.sh -t s2c
#  artifacts:
#    when: always
#    paths:
#      - VALIDATION_*.xml
#      - validation.log
#    expire_in: 1 week